;
; For all 80188 
;

INTREG			EQU	0xFF00			; internal register address (I/O)



IN_SERVICE_REGISTER	EQU	INTREG+0x2C		;





;	Base +offset
;	FF00	+20 to +3E		Interrupt Controller

Interrupt_Controller	equ	0xff20

iRMX_mode	equ	0

%if	iRMX_mode

Interrupt_Controller_vector			equ	Interrupt_Controller+0
Interrupt_Controller_end_of_interrupt		equ	Interrupt_Controller+2
Interrupt_Controller_mask			equ	Interrupt_Controller+8
Interrupt_Controller_priority			equ	Interrupt_Controller+0xA
Interrupt_Controller_in_service			equ	Interrupt_Controller+0xC
Interrupt_Controller_interrupt_request		equ	Interrupt_Controller+0xE
Interrupt_Controller_level_0_timer_0		equ	Interrupt_Controller+0x12
Interrupt_Controller_level_2_DMA_0		equ	Interrupt_Controller+0x14
Interrupt_Controller_level_3_DMA_1		equ	Interrupt_Controller+0x16
Interrupt_Controller_level_4_timer_1		equ	Interrupt_Controller+0x18
Interrupt_Controller_level_5_timer_2		equ	Interrupt_Controller+0x1A

%else

;	Interrupt_Controller_vector		equ	Interrupt_Controller+0
Interrupt_Controller_end_of_interrupt		equ	Interrupt_Controller+2
Interrupt_Controller_poll			equ	Interrupt_Controller+4
Interrupt_Controller_poll_status		equ	Interrupt_Controller+6
Interrupt_Controller_mask			equ	Interrupt_Controller+8
Interrupt_Controller_priority			equ	Interrupt_Controller+0xA
Interrupt_Controller_in_service			equ	Interrupt_Controller+0xC
Interrupt_Controller_interrupt_request		equ	Interrupt_Controller+0xE
Interrupt_Controller_status			equ	Interrupt_Controller+0x10
Interrupt_Controller_level_0_timer_0		equ	Interrupt_Controller+0x12
Interrupt_Controller_level_2_DMA_0		equ	Interrupt_Controller+0x14
Interrupt_Controller_level_3_DMA_1		equ	Interrupt_Controller+0x16

Interrupt_Controller_interrupt_0_control	equ	Interrupt_Controller+0x18
Interrupt_Controller_interrupt_1_control	equ	Interrupt_Controller+0x1A
Interrupt_Controller_interrupt_2_control	equ	Interrupt_Controller+0x1C
Interrupt_Controller_interrupt_3_control	equ	Interrupt_Controller+0x1E


%endif


Timer_0		equ	0xff50
;		+50 to +56		Timer 0 Control
Timer_1		equ	0xff58
;		+58 to +5E		Timer 1 Control
Timer_2		equ	0xff60
;		+60 to +66		Timer 2 Control


UMCS		equ	INTREG+0xA0	;	Upper Memory Chip Select
LMCS		equ	INTREG+0xA2	;	Lower Memory Chip Select
PACS		equ	INTREG+0xA4	;	Peripheral Base Address Control
MMCS		equ	INTREG+0xA6	; 	Middle Memory Chip Select
MPCS		equ	INTREG+0xA8	;	Middle Peripheral Chip Select

DMA_channel_0	equ	INTREG+0xC0	;	+C0 to +CA	DMA Descriptors Channel 0

DMA_channel_0_source_A15_A0		equ	DMA_channel_0+0
DMA_channel_0_source_A19_A16		equ	DMA_channel_0+2
DMA_channel_0_destination_A15_A0	equ	DMA_channel_0+4
DMA_channel_0_destination_A19_A16	equ	DMA_channel_0+6
DMA_channel_0_transfer_count		equ	DMA_channel_0+8
DMA_channel_0_control_word		equ	DMA_channel_0+10


DMA_channel_1	equ	INTREG+0xD0	;	+D0 to +DA	DMA Descriptors Channel 1

DMA_channel_1_source_A15_A0		equ	DMA_channel_1+0
DMA_channel_1_source_A19_A16		equ	DMA_channel_1+2
DMA_channel_1_destination_A15_A0	equ	DMA_channel_1+4
DMA_channel_1_destination_A19_A16	equ	DMA_channel_1+6
DMA_channel_1_transfer_count		equ	DMA_channel_1+8
DMA_channel_1_control_word		equ	DMA_channel_1+10

IO_relocation_register			equ	0xFFFE

;		+FE			Relocation register
;

