
%macro	cmp_ax_w	1	
	db	0x3d	; force opcode
	dw	%1	
%endmacro

%macro	inc_dx_twice	0	
	inc	dx
	inc	dx
%endmacro

%macro	out_at_port_data	2
	mov	dx,%1
	mov	ax,%2
	out	(dx),ax
%endmacro

%macro	out_at_dx	1	
	mov	ax,%1
	out	(dx),ax
%endmacro

%macro	out_ax_at_addr	1
	mov	dx,%1
	out	(dx),ax
%endmacro

%macro	in_al_from_addr	1
	mov	dx,%1
	in	al,dx
%endmacro


; force opcodes. ;;;	xor	ax,ax generates 0x31,0xc0

%macro	clr_ax	0
	db	0x33, 0xC0			
%endmacro

; force opcodes. ;;;	xor	ah,ah	fails
%macro	clr_ah	0
	db	0x32, 0xe4			
%endmacro


; force opcodes. ;;;	push word 0x0040 generates 0x6a,0x40 

%macro	push_w	1
	db	0x68
	dw	%1
%endmacro

%macro	push_through_ax	1
	mov ax,%1
	push ax
%endmacro

%macro	mov_sp_bp	0
	db	0x8b, 0xe5
%endmacro

%macro	mov_bp_sp	0
	db	0x8b, 0xec
%endmacro

%macro	xor_bh_bh	0
	db	0x32, 0xff	;;	xor	bh,bh
%endmacro

%macro	and_ax_ax	0
	db	0x23,0xc0	;;;	and	ax,ax
%endmacro

%macro	load_dxax	1
	mov	ax,[%1]
	mov	dx,[%1+2]
%endmacro

%macro	store_dxax	1
	mov	[%1+2],dx
	mov	[%1],ax
%endmacro

%macro	move_through_dxax	2
	load_dxax	%2
	store_dxax	%1
%endmacro






